/*
 * Copyright (c) 2017, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * WSO2 Inc. licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.ballerinalang.nativeimpl.lang.utils;

/**
 * Constants related to Ballerina model packages.
 */
public class Constants {
    
    /**
     * HTTP content-type application/json.
     */
    public static final String APPLICATION_JSON = "application/json";
    
    /**
     * HTTP content-type application/xml.
     */
    public static final String APPLICATION_XML = "application/xml";
    
    /**
     * HTTP content-type text/plain.
     */
    public static final String TEXT_PLAIN = "text/plain";

    /**
     * HTTP content-type application/octet-stream.
     */
    public static final String OCTET_STREAM = "application/octet-stream";

    /**
     * HTTP content-type application/x-www-form-urlencoded.
     */
    public static final String APPLICATION_FORM = "application/x-www-form-urlencoded";
}
